package com.huimv.admin.controller;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.conditions.query.QueryChainWrapper;
import com.huimv.admin.common.utils.Result;
import com.huimv.admin.entity.EnvDevice;
import com.huimv.admin.service.IEnvDeviceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author author
 * @since 2023-02-13
 */
@RestController
@RequestMapping("/envDevice")
@CrossOrigin
public class EnvDeviceController {
    @Autowired
    private IEnvDeviceService envDeviceService;

    @RequestMapping("/DeviceCount")
    public Result getDevice(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return envDeviceService.count(httpServletRequest, paramsMap);
    }

    @RequestMapping("/DeviceList")
    public Result getDeviceList(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return envDeviceService.list(httpServletRequest, paramsMap);
    }

    @RequestMapping("/DeviceAdd")
    public Result getDeviceAdd(HttpServletRequest httpServletRequest, @RequestBody EnvDevice envDevice) {
        return envDeviceService.add(httpServletRequest, envDevice);
    }

    @RequestMapping("/DeviceEdit")
    public Result getDeviceEdit(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return envDeviceService.edit(httpServletRequest, paramsMap);
    }

    @RequestMapping("/DeviceDelete")
    public Result getDeviceDelete(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return envDeviceService.delete(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listPigpen")
    public Result listPigpen(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return envDeviceService.listPigpen(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listPigpenAll")
    public Result listPigpenAll(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return envDeviceService.listPigpenAll(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listEnv")
    public Result listEnv(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return envDeviceService.listEnv(httpServletRequest, paramsMap);
    }

    @RequestMapping("/listDeviceCount")
    public Result listDeviceCount(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return envDeviceService.listDeviceCount(httpServletRequest, paramsMap);
    }

    @RequestMapping("/bandingUnitId")
    public Result bandingUnitId(HttpServletRequest httpServletRequest, @RequestBody EnvDevice envDevice) {
        return envDeviceService.bandingUnitId(httpServletRequest, envDevice);
    }

    @RequestMapping("/unBandingUnitId")
    public Result unBandingUnitId(HttpServletRequest httpServletRequest, @RequestBody EnvDevice envDevice) {
        envDevice.setUnitId(0);
        envDevice.setUnitName("");
        envDeviceService.updateById(envDevice);
        return new Result(10000, "解绑成功", true);
    }

    @RequestMapping("/selectList")
    public Result selectList(HttpServletRequest httpServletRequest, @RequestBody Map<String, String> paramsMap) {
        return envDeviceService.selectList(httpServletRequest, paramsMap);
    }

    @PostMapping("/listDetail")
    public Result listDetail(@RequestBody Map<String, String> paramsMap) {
        return envDeviceService.listDetail(paramsMap);
    }

    //给安卓集控的同步设备
    @PostMapping("/getList")
    public JSONObject getList() {
        QueryWrapper<EnvDevice> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("farm_id", 28).orderByAsc("id");
        List<EnvDevice> list = envDeviceService.list(queryWrapper);
        JSONObject jsonObject = new JSONObject();
        JSONArray jsonArray = new JSONArray();
        for (EnvDevice envDevice : list) {
            JSONObject object = new JSONObject();
            object.put("deviceCode", envDevice.getDeviceCode());
            object.put("deviceName", envDevice.getDeviceSortCode());
            object.put("buildLocation", envDevice.getBuildLocation());
            object.put("unitId", envDevice.getUnitId());
            object.put("age", envDevice.getDayAge());
            object.put("fengNum", envDevice.getFengJiNum());
            object.put("fengBianNum", envDevice.getFengJiBianNum());
            object.put("shilian", envDevice.getShiLianNum());
            object.put("jiare", envDevice.getJiaReQiNum());
            object.put("penwu", envDevice.getPenWuNum());
            object.put("chuchou", envDevice.getChuChouNum());
            object.put("zhaoming", envDevice.getZhaoMingDengNum());
            jsonArray.add(object);
        }
        jsonObject.put("list", jsonArray);
        return jsonObject;
    }
}
